unit PluginMain;


interface


uses

   Windows,

   Messages,

   SysUtils,

   Classes,

   Dialogs,

   Forms,

   upfIntf, 

   upfVisualClasses,

   CustomIntf;


type


  TupfVisualPlugin2 = class(TupfVisualPlugin, ICustomPluginInfo)

  private

    { Private declarations }

  public

     procedure DoSomething;

  end;


procedure Register;

procedure UnRegister;


implementation


var

  // CHANGE!

  // TupfVisualPlugin1 should be replaced with the name of your new

  // plugin type. For Example, TMyNewVisualPlugin.

  APlugin : TupfVisualPlugin2;


{$R *.DFM}


// IMPORTANT!

// Changes will be required here if you change the name of the visual

// plugin.

// These changes are marked below:

procedure Register;

var

  AppSvc : IupfCommandServices;

  j      : integer;

begin

  // CHANGE!

  // TupfVisualPlugin1 should be replaced with the name of your new

  // plugin type. For Example, TMyNewVisualPlugin.

  APlugin := TupfVisualPlugin2.Create(nil);
  if assigned(ApplicationServices) then
  begin
    AppSvc := ApplicationServices as IupfCommandServices;
    AppSvc.RegisterPlugin(APlugin);
    for j := 0 to APlugin.Commands.Count - 1 do
      AppSvc.RegisterCommand(APlugin, APlugin.Commands[j]);
  end;
end;


procedure UnRegister;

begin

  // Free the plugin

  APlugin.Free;
end;


{ TupfVisualPlugin2 }

procedure TupfVisualPlugin2.DoSomething;
var
   AppSvc : ICustomAppServices;
begin
   if Assigned(ApplicationServices) then
      if Supports(ApplicationServices, ICustomAppServices, AppSvc) then
      begin
         ShowMessage('Custom plugin method : ' + IntToStr(AppSvc.Value));
      end;
   AppSvc := nil;
end;

end. 